comment!
************************************************************************
*  Diese Routine bietet die Mglichkeit, von BASICA oder GWBASIC aus   *
*  jeden beliebigen Interrupt aufzurufen                               *
**--------------------------------------------------------------------**
*  Aufruf:                                                             *
*  CALL ADR(INTNR%,AH%,AL%,BH%,BL%,CH%,CL%,DH%,DL%,DI%,SI%,ES%,FLAGS%) *
**--------------------------------------------------------------------**
*  Bei bergabe der Kontrolle an das Maschinenspracheprogramm legt     *
*  BASIC die einzelnen Variablen an folgende Positionen auf den Stack  *
*  INTNR% = SP+30   AH%    = SP+28   AL%    = SP+26   BH%    = SP+24   *
*  BL%    = SP+22   CH%    = SP+20   CL%    = SP+18   DH%    = SP+16   *
*  DL%    = SP+14   DI%    = SP+12   SI%    = SP+10   ES%    = SP+8    *
*  FLAGS% = SP+6                                                       *
**--------------------------------------------------------------------**
*  wird fr ES der Wert -1 bergeben, dann wird ES auf DS gesetzt      *
***********************************************************************!
                                                                        
code      segment
                                                                        
          assume cs:code,ds:code,es:code,ss:code
                                                                        
;-- die Routine zum Interrupt-Aufruf -----------------------------------
                                                                        
basint    proc far                ;GW erwartet bei CALL Far-Procedure
                                                                        
          push bp                 ;GW Basepointer merken
          mov  bp,sp              ;SP nach BP bertragen
          push ds                 ;GW Datensegment merken
          push es                 ;GW Extrasegment merken
                                                                        
          mov  si,[bp+30]         ;Adresse der Variablen INTNR holen
          mov  ax,[si]            ;Inhalt dieser Variablen nach AX holen
          call set_intnr          ;Interrupt-Nummer speichern
                                                                        
ad_1      label near              ;Adresse fr SET_INTNR
                                                                        
          mov  si,[bp+12]         ;Adresse der Variablen DI% holen
          mov  di,[si]            ;Inhalt dieser Variablen nach DI holen
          mov  si,[bp+8]          ;Adresse der Variablen ES% holen
          mov  ax,[si]            ;Inhalt dieser Variablen nach AX holen
          cmp  ax,-1              ;wurde -1 bergeben?
          jne  setes              ;NEIN --> ES so setzen
                                                                        
          mov  ax,ds              ;AX auf DS setzen und damit ES = DS
                                                                        
setes:    mov  es,ax              ;von AX nach ES transferieren
          mov  si,[bp+28]         ;Adresse der Variablen AH% holen
          mov  ah,[si]            ;Inhalt dieser Variablen nach AH holen
          mov  si,[bp+26]         ;Adresse der Variablen AL% holen
          mov  al,[si]            ;Inhalt dieser Variablen nach AL holen
          mov  si,[bp+24]         ;Adresse der Variablen BH% holen
          mov  bh,[si]            ;Inhalt dieser Variablen nach BH holen
          mov  si,[bp+22]         ;Adresse der Variablen BL% holen
          mov  bl,[si]            ;Inhalt dieser Variablen nach BL holen
          mov  si,[bp+20]         ;Adresse der Variablen CH% holen
          mov  ch,[si]            ;Inhalt dieser Variablen nach CH holen
          mov  si,[bp+18]         ;Adresse der Variablen CL% holen
          mov  cl,[si]            ;Inhalt dieser Variablen nach CL holen
          mov  si,[bp+16]         ;Adresse der Variablen DH% holen
          mov  dh,[si]            ;Inhalt dieser Variablen nach DH holen
          mov  si,[bp+14]         ;Adresse der Variablen DL% holen
          mov  dl,[si]            ;Inhalt dieser Variablen nach DL holen
                                                                        
          mov  si,[bp+10]         ;Adresse der Variablen SI% holen
          mov  si,[si]            ;Inhalt dieser Variablen nach SI holen
          push bp                 ;Basepointer merken
                                                                        
ad_2      label near              ;Adresse fr SET_INTNR
                                                                        
          int  21h                ;Interrupt aufrufen
                                                                        
          pop  bp                 ;Basepointer zurckholen
          push si                 ;SI merken
          pushf                   ;Flag-Register merken
                                                                        
          mov  si,[bp+12]         ;Adresse der Variablen DI% holen
          mov  [si],di            ;Inhalt dieser Variablen nach DI holen
          mov  si,[bp+28]         ;Adresse der Variablen AH% holen
          mov  [si],ah            ;AH in diese Variable eintragen
          mov  si,[bp+26]         ;Adresse der Variablen AL% holen
          mov  [si],al            ;AL in diese Variable eintragen
          mov  si,[bp+24]         ;Adresse der Variablen BH% holen
          mov  [si],bh            ;BH in diese Variable eintragen
          mov  si,[bp+22]         ;Adresse der Variablen BL% holen
          mov  [si],bl            ;BL in diese Variable eintragen
          mov  si,[bp+20]         ;Adresse der Variablen CH% holen
          mov  [si],ch            ;CH in diese Variable eintragen
          mov  si,[bp+18]         ;Adresse der Variablen CL% holen
          mov  [si],cl            ;CL in diese Variable eintragen
          mov  si,[bp+16]         ;Adresse der Variablen DH% holen
          mov  [si],dh            ;DH in diese Variable eintragen
          mov  si,[bp+14]         ;Adresse der Variablen DL% holen
          mov  [si],dl            ;DL in diese Variable eintragen
          mov  si,[bp+8]          ;Adresse der Variablen ES% holen
          mov  ax,es              ;ES nach AX transferieren
          mov  [si],ax            ;ES (AX) in diese Variable eintragen
          pop  ax                 ;Flag-Register vom Stack nach AX holen
          mov  si,[bp+6]          ;Adresse der Variablen FLAGS% holen
          mov  [si],ax            ;FLAGs in diese Variable eintragen
          pop  ax                 ;DI-Register vom Stack nach AX holen
          mov  si,[bp+10]         ;Adresse der Variablen SI% holen
          mov  [si],ax            ;SI (AX) in diese Variable eintragen
                                                                        
          pop  es                 ;GW Extrasegment zurckholen
          pop  ds                 ;GW Datensegment zurckholen
          pop  bp                 ;GW Basepointer zurckholen
                                                                        
          ret  26                 ;Adressen der Variablen auf dem Stack
                                  ;werden nicht mehr gebraucht
                                                                        
basint    endp
                                                                        
;-----------------------------------------------------------------------
                                                                        
set_intnr proc near               ;speichert die Interrupt-Nummer
                                                                        
          pop  bx
          mov  cs:[bx+ad_2-ad_1+1],al
          jmp  ad_1
                                                                        
set_intnr endp
                                                                        
;-----------------------------------------------------------------------
                                                                        
code      ends
          end
